<?php

namespace IPS\tutorials;

class _Application extends \IPS\Application
{
	public function init()
	{
		if ( \IPS\Dispatcher::i()->controllerLocation === 'front' )
		{
			$data = \IPS\tutorials\Members::getMemberData( \IPS\Member::loggedIn()->member_id );
			if( !\IPS\Member::loggedIn()->group['g_tutorials_view'] OR ( \IPS\Member::loggedIn()->member_id AND !$data['allowed_access'] ) )
			{
				\IPS\Output::i()->error( 'no_access_tutorials', 'TUTORIALS-ACCESS/1', 404, '' );
			}

			if( \IPS\Member::loggedIn()->group['g_tutorials_posts_access'] > 0 AND \IPS\Member::loggedIn()->member_id )
			{
				if ( \IPS\Member::loggedIn()->group['g_tutorials_posts_access'] > \IPS\Member::loggedIn()->member_posts )
				{
					\IPS\Output::i()->error( 'no_access_tutorials_posts', 'TUTORIALS-ACCESS/2', 404, '' );
				}
			}
		}
	}

	protected function get__icon()
	{
		return 'comments';
	}

	public function installOther()
	{
		foreach( \IPS\Member\Group::groups( TRUE, FALSE ) as $group )
		{
			if( $group->g_id == \IPS\Settings::i()->admin_group )
			{
				$group->g_tutorials_viewreaders 	= TRUE;
				$group->g_tutorials_tutorializepost	= TRUE;
				$group->g_tutorials_copy 			= TRUE;
				$group->save();
			}
		}
	}

	public function defaultFrontNavigation()
	{
		return array(
			'rootTabs'		=> array(),
			'browseTabs'	=> array( array( 'key' => 'Tutorials' ) ),
			'browseTabsEnd'	=> array(),
			'activityTabs'	=> array()
		);
	}
}