<?php
/**
 * @brief		Create Menu Extension : Tutorials
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	
 * @since		12 Dec 2014
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\tutorials\extensions\core\CreateMenu;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Create Menu Extension: Tutorials
 */
class _Tutorials
{
	/**
	 * Get Items
	 *
	 * @return	array
	 */
	public function getItems()
	{
		if ( \IPS\tutorials\Category::canOnAny( 'add', NULL, \IPS\Settings::i()->club_nodes_in_apps ? array() : array( array( 'c_club_id IS NULL' ) ) ) )
		{
			return array(
				'new_tutorial' => array(
					'link' 		=> \IPS\Http\Url::internal( "app=tutorials&module=tutorials&controller=submit&_new=1", 'front', 'tutorials_submit' ),
					'title' 	=> 'select_category',
					'extraData'	=> array( 'data-ipsDialog' => true, 'data-ipsDialog-size' => "narrow" )
				)
			);
		}

		return array();
	}
}