<?php
/**
 * @brief		Dashboard extension: Overview
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	
 * @since		15 Dec 2014
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\tutorials\extensions\core\Dashboard;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Dashboard extension: Overview
 */
class _Overview
{
	/** 
	 * Return the block HTML show on the dashboard
	 *
	 * @return	string
	 */
	public function getBlock()
	{
		/* Basic stats */
		$data = array(
			'total_categories'	=> (int) \IPS\Db::i()->select( 'COUNT(*)', 'tutorials_cats' )->first(),
			'total_articles'	=> (int) \IPS\Db::i()->select( 'COUNT(*)', 'tutorials_articles' )->first(),
			'total_views'		=> (int) \IPS\Db::i()->select( 'SUM(a_views)', 'tutorials_articles' )->first()
		);

		/* Specific articles (will fail if no articles yet) */
		try
		{
			$data['newest_article'] 	 = \IPS\tutorials\Article::constructFromData( \IPS\Db::i()->select( '*', 'tutorials_articles', NULL, 'a_id DESC', 1 )->first() );
			$data['most_viewed_article'] = \IPS\tutorials\Article::constructFromData( \IPS\Db::i()->select( '*', 'tutorials_articles', NULL, 'a_views DESC', 1 )->first() );
			$data['most_comm_article'] 	 = \IPS\tutorials\Article::constructFromData( \IPS\Db::i()->select( '*', 'tutorials_articles', NULL, 'a_comments DESC', 1 )->first() );
			$data['top_author'] 		 = \IPS\tutorials\Article::constructFromData( \IPS\Db::i()->select( 'a_mid, core_members.name as user, count(*) as cnt', 'tutorials_articles', NULL, 'cnt DESC', 1, 'a_mid' )->join( 'core_members', 'core_members.member_id=tutorials_articles.a_mid' )->first() );
		}
		catch ( \Exception $e ) { }

		/* Display */
		return \IPS\Theme::i()->getTemplate( 'dashboard', 'tutorials' )->overview( $data );
	}
}