<?php
/**
 * @brief		Admin CP Group Form
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	
 * @since		16 Dec 2014
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\tutorials\extensions\core\GroupForm;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Admin CP Group Form
 */
class _Tutorials
{
	/**
	 * Process Form
	 *
	 * @param	\IPS\Form\Tabbed		$form	The form
	 * @param	\IPS\Member\Group		$group	Existing Group
	 * @return	void
	 */
	public function process( &$form, $group )
	{
		$form->addHeader( 'global_options' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'g_tutorials_view', $group->g_tutorials_view ) );
		
		if( $group->g_id != \IPS\Settings::i()->guest_group )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'g_tutorials_posts_access', $group->g_tutorials_posts_access, FALSE, array( 'unlimited' => 0, 'unlimitedLang' => 'g_tutorials_posts_access_unlimited' ), NULL, NULL, NULL, 'g_tutorials_posts_access' ) );

			$form->addHeader( 'tutorial_viewing' );
			$form->add( new \IPS\Helpers\Form\YesNo( 'g_tutorials_viewreaders', $group->g_tutorials_viewreaders ) );

			$form->addHeader( 'tutorial_creation' );
			$form->add( new \IPS\Helpers\Form\YesNo( 'g_tutorials_tutorializepost', $group->g_tutorials_tutorializepost ) );
			$form->add( new \IPS\Helpers\Form\YesNo( 'g_tutorials_othermems', $group->g_tutorials_othermems ) );
			$form->add( new \IPS\Helpers\Form\YesNo( 'g_tutorials_copy', $group->g_tutorials_copy ) );
		}
	}
	
	/**
	 * Save
	 *
	 * @param	array				$values	Values from form
	 * @param	\IPS\Member\Group	$group	The group
	 * @return	void
	 */
	public function save( $values, &$group )
	{
		$group->g_tutorials_view 		 = $values['g_tutorials_view'];

		if( $group->g_id != \IPS\Settings::i()->guest_group )
		{
			$group->g_tutorials_posts_access = $values['g_tutorials_posts_access'];
			$group->g_tutorials_viewreaders	 = $values['g_tutorials_viewreaders'];
			$group->g_tutorials_othermems	 = $values['g_tutorials_othermems'];
			$group->g_tutorials_copy 		 = $values['g_tutorials_copy'];
			$group->g_tutorials_tutorializepost	 = $values['g_tutorials_tutorializepost'];
		}
	}
}