<?php
/**
 * @brief		Member ACP Profile - Content Statistics Tab
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Tutorials
 * @since		30 Mar 2018
 */

namespace IPS\tutorials\extensions\core\MemberACPProfileContentTab;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Member ACP Profile - Content Statistics Tab: Gallery
 */
class _tutorials extends \IPS\core\MemberACPProfile\Block
{
	/**
	 * Get output
	 *
	 * @return	string
	 */
	public function output()
	{
		$articlesCount = \IPS\Db::i()->select( 'COUNT(*)', 'tutorials_articles', array( 'a_mid=?', $this->member->member_id ) )->first();
		$allArticles = \IPS\Db::i()->select( 'COUNT(*)', 'tutorials_articles' )->first();
		return \IPS\Theme::i()->getTemplate( 'stats', 'tutorials' )->information( $this->member, \IPS\Theme::i()->getTemplate( 'global', 'core' )->definitionTable( array(
			'tutorials_created'		=>
				\IPS\Member::loggedIn()->language()->addToStack('tutorials_stat_of_total', FALSE, array( 'sprintf' => array(
						\IPS\Member::loggedIn()->language()->formatNumber( $articlesCount ),
						\IPS\Member::loggedIn()->language()->formatNumber( ( ( $allArticles ? ( 100 / $allArticles ) : 0 ) * $articlesCount ), 2 ) ) )
				)
		) ) );
	}
}