<?php


namespace IPS\tutorials\setup\upg_200001;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.0.1 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
        $data = \IPS\tutorials\Category::roots();

        $store = array();

        foreach( $data as $k => $v )
		{
            $store[ $v->id ] = array
			(
                'id' 			=> $v->id,
                'seo_title' 	=> $v->name_seo,
                'permission'	=> $v->permissions()
            );
        }

        if( isset( \IPS\Data\Store::i()->tutorials_cats ) )
		{
            unset( \IPS\Data\Store::i()->tutorials_cats );
        }

		\IPS\Data\Store::i()->tutorials_cats = $store;

		return true;
	}

	/**
	 * Custom title for this step
	 *
	 * @return string
	 */
	public function step1CustomTitle()
	{
		return "Updating data for the Categories on Naviagation Bar";
	}
}