<?php


namespace IPS\tutorials\setup\upg_210007;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.2.0 Beta 3 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
		/*if( !\IPS\Db::i()->checkForColumn( 'tutorials_cats', 'c_club_id' ) )
		{
			\IPS\Db::i()->addColumn( 'tutorials_cats', array
			(
				'name'				=> 'c_club_id',
				'type'				=> 'bigint',
				'length'			=> 20,
				'allow_null'		=> TRUE,
				'default' 			=> NULL,
				'auto_increment'	=> FALSE
			) );
		}*/

		\IPS\Db::i()->addColumn( 'tutorials_cats', array
		(
			'name' => 'c_allow_reviews',
			'type' => 'TINYINT',
			'length' => 1,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => false,
			'default' => 0,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		\IPS\Db::i()->addColumn( 'tutorials_cats', array
		(
			'name' => 'c_moderate_reviews',
			'type' => 'TINYINT',
			'length' => 1,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => false,
			'default' => 0,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		\IPS\Db::i()->addColumn( 'tutorials_articles', array
		(
			'name' => 'a_reviews',
			'type' => 'INT',
			'length' => 11,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => false,
			'default' => 0,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		\IPS\Db::i()->addColumn( 'tutorials_articles', array (
			'name' => 'a_last_review',
			'type' => 'INT',
			'length' => 10,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => false,
			'default' => 0,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		\IPS\Db::i()->addColumn( 'tutorials_articles', array (
			'name' => 'a_unapproved_reviews',
			'type' => 'INT',
			'length' => 10,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => true,
			'default' => NULL,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		\IPS\Db::i()->addColumn( 'tutorials_articles', array (
			'name' => 'a_hidden_reviews',
			'type' => 'INT',
			'length' => 10,
			'decimals' => NULL,
			'values' => NULL,
			'allow_null' => true,
			'default' => NULL,
			'comment' => '',
			'unsigned' => false,
			'zerofill' => false,
			'auto_increment' => false,
			'binary' => false,
		) );

		return TRUE;
	}

	/**
	 * Custom title for this step
	 *
	 * @return string
	 */
	public function step1CustomTitle()
	{
		return "Adding new database columns";
	}

	/**
	 * Step 2
	 * Convert Ratings
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step2()
	{
		if( !\IPS\Db::i()->checkForTable( 'tutorials_reviews' ) )
		{
			\IPS\Db::i()->createTable( array(
				'name'		=> 'tutorials_reviews',
				'columns'	=> array(
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> true,
		                "binary"			=> false,
		                "comment"			=> "ID Number",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 20,
		                "name"				=> "review_id",
		                "type"				=> "BIGINT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The article ID",
		                "decimals"			=> null,
		                "default"			=> "0",
		                "length"			=> 10,
		                "name"				=> "review_aid",
		                "type"				=> "INT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The member ID of the review author",
		                "decimals"			=> null,
		                "default"			=> "0",
		                "length"			=> 20,
		                "name"				=> "review_mid",
		                "type"				=> "BIGINT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The review contents",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 0,
		                "name"				=> "review_text",
		                "type"				=> "MEDIUMTEXT",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Boolean indicating if edit message should show",
		                "decimals"			=> null,
		                "default"			=> "0",
		                "length"			=> 1,
		                "name"				=> "review_append_edit",
		                "type"				=> "TINYINT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Unix timestamp of when the review was last edited",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 10,
		                "name"				=> "review_edit_time",
		                "type"				=> "INT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Username of user who last edited review",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 255,
		                "name"				=> "review_edit_name",
		                "type"				=> "VARCHAR",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Unix timestamp of when review was made",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 10,
		                "name"				=> "review_date",
		                "type"				=> "INT",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "IP address review was made from",
		                "decimals"			=> null,
		                "default"			=> "",
		                "length"			=> 46,
		                "name"				=> "review_ip",
		                "type"				=> "VARCHAR",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Username of user who made review",
		                "decimals"			=> null,
		                "default"			=> "",
		                "length"			=> 255,
		                "name"				=> "review_author_name",
		                "type"				=> "VARCHAR",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The rating (out of 5) with the review",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 1,
		                "name"				=> "review_rating",
		                "type"				=> "TINYINT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The number of people who have voted \"helpful\" or \"unhelpful\"",
		                "decimals"			=> null,
		                "default"			=> "0",
		                "length"			=> 10,
		                "name"				=> "review_votes",
		                "type"				=> "INT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The number of people who have voted \"helpful\"",
		                "decimals"			=> null,
		                "default"			=> "0",
		                "length"			=> 10,
		                "name"				=> "review_votes_helpful",
		                "type"				=> "INT",
		                "unsigned"			=> true,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "JSON object containing data about who has voted helpful\/unhelpful ",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 0,
		                "name"				=> "review_votes_data",
		                "type"				=> "TEXT",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> true,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "The version being reviewed",
		                "decimals"			=> null,
		                "default"			=> null,
		                "length"			=> 32,
		                "name"				=> "review_version",
		                "type"				=> "VARCHAR",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
					array(
		                "allow_null"		=> false,
		                "auto_increment"	=> false,
		                "binary"			=> false,
		                "comment"			=> "Review is approved?",
		                "decimals"			=> null,
		                "default"			=> "1",
		                "length"			=> 1,
		                "name"				=> "review_approved",
		                "type"				=> "TINYINT",
		                "unsigned"			=> false,
		                "values"			=> [],
		                "zerofill"			=> false
					),
				),
				'indexes'	=> array(
					array(
						'type'		=> 'primary',
						'columns'	=> array( 'review_id' )
					),
					array(
						'type'		=> 'key',
						'name'		=> 'review_aid',
						'columns'	=> array( 'review_aid' )
					),
					array(
						'type'		=> 'key',
						'name'		=> 'review_mid',
						'columns'	=> array( 'review_mid' )
					),
					array(
						'type'		=> 'key',
						'name'		=> 'review_ip',
						'columns'	=> array( 'review_ip' )
					),
					array(
						'type'		=> 'key',
						'name'		=> 'review_approved',
						'columns'	=> array( 'review_approved' )
					),
				)
			)	);
		}

		return TRUE;
	}

	/**
	 * Custom title for this step
	 *
	 * @return string
	 */
	public function step2CustomTitle()
	{
		return "Creating Tutorials Reviews table";
	}


	/**
	 * Step 3
	 * Convert Ratings
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step3()
	{
		$perCycle	= 1000;
		$did		= 0;
		$limit		= \intval( \IPS\Request::i()->extra );

		/* Try to prevent timeouts to the extent possible */
		$cutOff	= \IPS\core\Setup\Upgrade::determineCutoff();

		foreach( \IPS\Db::i()->select( '*', 'tutorials_articles', array( 'a_rating IS NOT NULL' ), 'a_id ASC', array( $limit, $perCycle ) ) as $article )
		{
			if( $cutOff !== null AND time() >= $cutOff )
			{
				return ( $limit + $did );
			}

			$did++;

			$votes = unserialize( $article['a_rating'] );
			$voteCount = 0;
			
			if ( is_array( $votes ) and \count( $votes ) )
			{
				foreach( $votes as $member => $rating )
				{
					try
					{
						$member = \IPS\Member::load( $member );

						\IPS\Db::i()->insert( 'tutorials_reviews', array(
							'review_aid'			=> $article['a_id'],
							'review_mid'			=> $member->member_id,
							'review_author_name'	=> $member->name,
							'review_rating'			=> $rating,
							/* The review_ip column does not accept NULL values */
							'review_ip'				=> '',
							'review_date'			=> time(),
							'review_approved'		=> 1,
							/* The search index does not allow blank text */
							'review_text'			=> '',
						) );
		
						$voteCount++;
					}
					catch( \Exception $e ){}
				}
			}
			
			\IPS\Db::i()->update( 'tutorials_articles', array( 'a_rating' => $article['a_rating'] + $voteCount ), array( "a_id=?", $article['a_id'] ) );
		}

		if( $did )
		{
			return ( $limit + $did );
		}
		else
		{
			unset( $_SESSION['_step3Count'] );
			return TRUE;
		}
	}

	/**
	 * Custom title for this step
	 *
	 * @return string
	 */
	public function step3CustomTitle()
	{
		$limit = isset( \IPS\Request::i()->extra ) ? \IPS\Request::i()->extra : 0;

		if( !isset( $_SESSION['_step3Count'] ) )
		{
			$_SESSION['_step3Count'] = \IPS\Db::i()->select( 'COUNT(*)', 'tutorials_articles', array( 'a_rating IS NOT NULL' ) )->first();
		}

		return "Converting file ratings (Updated so far: " . ( ( $limit > $_SESSION['_step3Count'] ) ? $_SESSION['_step3Count'] : $limit ) . ' out of ' . $_SESSION['_step3Count'] . ')';
	}
}