<?php


namespace IPS\tutorials\setup\upg_210022;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.4.2 Upgrade Code
 */
class _Upgrade
{
	public function step1()
	{
		\IPS\Task::queue( 'tutorials', 'membersTable', array(), 2 );

		return TRUE;
	}

	public function step1CustomTitle()
	{
		return "Updating member's preference";
	}

	public function step2()
	{
		\IPS\Db::i()->dropTable( 'tutorials_announcements', TRUE );

		return TRUE;
	}

	public function step2CustomTitle()
	{
		return "Dropping unused table";
	}

	public function step3()
	{
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'tutorials', 'block_latestTutorialsComments' ) );
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'tutorials', 'block_latestTutorialsComments_desc' ) );
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'tutorials', 'comm_to_show' ) );
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'tutorials', 'comm_exclude_groups' ) );

		return TRUE;
	}

	public function step3CustomTitle()
	{
		return "Deleting unused language bits";
	}
}