<?php

namespace IPS\tutorials;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Field extends \IPS\CustomField
{
	protected static $multitons;
	public static $databaseTable = 'tutorials_cfields';
	public static $databasePrefix = 'cf_';
	public static $databaseColumnOrder = 'position';

	public static $databaseColumnMap = array(
		'not_null'	=> 'not_null'
	);

	public static $nodeTitle = 'menu__tutorials_tutorials_fields';
	protected static $langKey = 'tutorials_field';
	public static $titleLangPrefix = 'tutorials_field_';
	public static $contentDatabaseTable = 'tutorials_ccontent';

	protected static $restrictions = array(
		'app'		=> 'tutorials',
		'module'	=> 'tutorials',
		'prefix'	=> 'fields_',
	);

	public static $editorOptions = array( 'app' => 'tutorials', 'key' => 'Tutorials' );
	public static $uploadStorageExtension = 'ArticleField';

	public function get_topic_format()
	{
		return $this->format;
	}

	public function form( &$form )
	{
		parent::form( $form );

		$form->add( new \IPS\Helpers\Form\Radio( 'tutorials_field_location', $this->id ? $this->display_location : 'sidebar', FALSE, array( 'options' => array( 'sidebar' => 'tutorials_cfield_sidebar', 'below' => 'tutorials_cfield_below' ) ), NULL, NULL, NULL, 'tutorials_field_location' ) );
	}
	
	public function formatFormValues( $values )
	{
		$values['search_type']			= ( $values['pf_search_type'] === NULL ) ? '' : $values['pf_search_type'];
		$values['allow_attachments']	= $values['pf_allow_attachments'];
		unset( $values['pf_search_type'] );
		unset( $values['pf_allow_attachments'] );

		$values['display_location'] = $values['tutorials_field_location'];
		unset( $values['tutorials_field_location'] );

		return parent::formatFormValues( $values );
	}
}