<?php

namespace IPS\tutorials;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Members
{
	public static function getMemberData( $memberId )
	{
		try
		{
			$data = \IPS\Db::i()->select( 'allowed_access, block_submissions', 'tutorials_members', array( 'member_id=?', $memberId ) )->first();
		}
		catch ( \UnderflowException $e )
		{
			$data = array( 'allowed_access' => 1, 'block_submissions' => 1 );
		}

		return $data;
	}

	public static function setMemberData( $memberId, $allowedAccess, $blockSubmissions )
	{
		\IPS\Db::i()->replace( 'tutorials_members',
			array(
				'member_id'			=> $memberId,
				'allowed_access'	=> $allowedAccess,
				'block_submissions'	=> $blockSubmissions
			)
		);
	}

	public function dummy()
	{
		//nothing here
	}
}