<?php

/**
 * @brief         Store Class
 * @author        <a href='http://codingjungle.com'>Michael S. Edwards</a>
 * @copyright     (c) 2015 Michael S. Edwards
 * @package       IPS Social Suite
 * @subpackage    Tutoarials
 * @since         30 Jun 2015
 * @version       2.0.1
 */

namespace IPS\tutorials;

class _Store extends \IPS\Patterns\Singleton {

    /**
     * @brief    Singleton Instances
     * @note     This needs to be declared in any child classes as well, only declaring here for editor
     *           code-complete/error-check functionality
     */
    protected static $instance = null;

    public function updateCatsMenu()
	{
        $data = \IPS\tutorials\Category::roots();

        $store = array();

        foreach( $data as $k => $v )
		{
            $store[ $v->id ] = array
			(
                'id' 			=> $v->id,
                'seo_title' 	=> $v->name_seo,
                'permission'	=> $v->permissions()
            );
        }

        if( isset( \IPS\Data\Store::i()->tutorials_cats ) )
		{
            unset( \IPS\Data\Store::i()->tutorials_cats );
        }

        \IPS\Data\Store::i()->tutorials_cats = $store;
    }

	public static function canUsePoints()
	{
		if( \IPS\Application::appIsEnabled( 'membersshop' ) AND \IPS\Application::load( 'membersshop' )->long_version >= 11003 )
		{
			return TRUE;
		}

		return FALSE;
	}

	public function dummy()
	{
		//nothing here
	}
}